> ## Documentation Index
> Fetch the complete documentation index at: https://razorpay-881012b3.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Fetch All Customer Identifiers

> Fetch all Customer Identifiers using the Razorpay Smart Collect APIs.

<div style={{display:"flex",flexWrap:"wrap",alignItems:"center",gap:"0.35rem 0.9rem",border:"1px solid rgba(128,128,128,0.28)",borderRadius:"0.5rem",padding:"0.45rem 0.75rem",margin:"0 0 1.25rem",fontSize:"0.875rem"}}>
  <span style={{fontWeight:600}}>Available in</span>
  <span>🇮🇳 India</span>
  <span>🇸🇬 Singapore</span>
  <span>🇺🇸 United States</span>
</div>

Use this endpoint to retrieve details of all Customer Identifiers.

<RequestExample>
  ```bash Curl theme={null}
  curl -u [YOUR_KEY_ID]:[YOUR_KEY_SECRET] \
  -X GET \
  https://api.razorpay.com/v1/virtual_accounts \
  ```

  ```java Java theme={null}
  RazorpayClient razorpay = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]");

  JSONObject params = new JSONObject();
  params.put("count","1");

  List<VirtualAccount> virtualaccount = instance.virtualAccounts.fetchAll(params);
  ```

  ```python Python theme={null}
  import razorpay
  client = razorpay.Client(auth=("YOUR_ID", "YOUR_SECRET"))

  client.virtual_account.all(options)
  ```

  ```ruby Ruby theme={null}
  require "razorpay"
  Razorpay.setup('key_id', 'key_secret')

  options = {"count":1}

  Razorpay::VirtualAccount.all(options)
  ```

  ```php PHP theme={null}
  $api = new Api($key_id, $secret);

  $api->virtualAccount->all($options);
  ```

  ```javascript Node.js theme={null}
  var instance = new Razorpay({ key_id: 'YOUR_KEY_ID', key_secret: 'YOUR_SECRET' })

  instance.virtualAccounts.all(options)
  ```

  ```go Go theme={null}
  import ( razorpay "github.com/razorpay/razorpay-go" )
  client := razorpay.NewClient("YOUR_KEY_ID", "YOUR_SECRET")

  data:= map[string]interface{}{
      "count" : 1,
  }

  body, err := client.VirtualAccount.All(data, nil)
  ```

  ```ruby Ruby theme={null}
  require "razorpay"
  Razorpay.setup('YOUR_KEY_ID', 'YOUR_SECRET')

  options = {"count":1}

  Razorpay::VirtualAccount.all(options)
  ```

  ```csharp .NET theme={null}
  RazorpayClient client = new RazorpayClient("[YOUR_KEY_ID]", "[YOUR_KEY_SECRET]

  Dictionary<string, object> param = new Dictionary<string, object>();
  param.Add("count","1");

  List<VirtualAccount> virtualaccount = client.VirtualAccount.All(param);
  ```

  ```bash CLI theme={null}
  razorpay smart-collect list \
    --count 25 \
    --skip 0 \
    --from 1609459200 \
    --to 1612137600
  ```
</RequestExample>

<ResponseExample>
  ```json Success theme={null}
  {
    "entity": "collection",
    "count": 2,
    "items": [
      {
        "id": "va_Di5gbNptcWV8fQ",
        "name": "Acme Corp",
        "entity": "virtual_account",
        "status": "closed",
        "description": "Customer Identifier created for M/S ABC Exports",
        "amount_expected": 2300,
        "notes": {
          "material": "teakwood"
        },
        "amount_paid": 239000,
        "customer_id": "cust_DOMUFFiGdCaCUJ",
        "receivers": [
          {
            "id": "ba_Di5gbQsGn0QSz3",
            "entity": "bank_account",
            "ifsc": "RATN0VAAPIS",
            "bank_name": "RBL Bank",
            "name": "Acme Corp",
            "notes": [],
            "account_number": "1112220061746877"
          }
        ],
        "close_by": 1574427237,
        "closed_at": 1574164078,
        "created_at": 1574143517
      },
      {
        "id": "va_Dho86Avmdw6h09",
        "name": "Acme Corp",
        "entity": "virtual_account",
        "status": "active",
        "description": "Customer Identifier created for Raftar Soft",
        "amount_expected": null,
        "notes": {
          "material": "oakwood"
        },
        "amount_paid": 0,
        "customer_id": "cust_DOMUFFiGdCaDNK",
        "receivers": [
          {
            "id": "ba_Dho86DoV16LqiO",
            "entity": "bank_account",
            "ifsc": "RATN0VAAPIS",
            "bank_name": "RBL Bank",
            "name": "Acme Corp",
            "notes": [],
            "account_number": "1112220046254840"
          }
        ],
        "close_by": 1574427237,
        "closed_at": null,
        "created_at": 1574081690
      }
    ]
  }
  ```

  ```json Failure theme={null}
  {
    "error": {
      "code": "BAD_REQUEST_ERROR",
      "description": "The api key provided is invalid",
      "source": "NA",
      "step": "NA",
      "reason": "NA",
      "metadata": {}
    }
  }
  ```
</ResponseExample>

## Query Parameters

<ParamField query="from" type="integer">
  Timestamp, in seconds, from when Customer Identifiers are to be fetched.
</ParamField>

<ParamField query="to" type="integer">
  Timestamp, in seconds, till when Customer Identifiers are to be fetched.
</ParamField>

<ParamField query="count" type="integer">
  Number of Customer Identifiers to be fetched. The default value is 10 and the maximum value is 100. This can be used for pagination, in combination with `skip`.
</ParamField>

<ParamField query="skip" type="integer">
  Number of records to be skipped while fetching the Customer Identifiers. This can be used for pagination, in combination with `count`.
</ParamField>

## Response Parameters

<ResponseField name="id" type="string">
  The unique identifier of the Customer Identifier.
</ResponseField>

<ResponseField name="name" type="string">
  The `merchant billing label` as it appears on the Dashboard.
</ResponseField>

<ResponseField name="entity" type="string">
  Indicates the type of entity. Here, it is `virtual account`.
</ResponseField>

<ResponseField name="status" type="string">
  Indicates whether the Customer Identifier is in `active` or `closed` state.
</ResponseField>

<ResponseField name="description" type="string">
  A brief description about the Customer Identifier.
</ResponseField>

<ResponseField name="amount_expected" type="integer">
  The amount expected by the merchant.
</ResponseField>

<ResponseField name="amount_paid" type="integer">
  The amount paid by the customer into the Customer Identifier.
</ResponseField>

<ResponseField name="notes" type="json object">
  Any custom notes you might want to add to the Customer Identifier can be entered here. Know more about [notes](/docs/sg/api/understand#notes).
</ResponseField>

<ResponseField name="customer_id" type="string">
  Unique identifier of the customer the Customer Identifier is linked with. Know more about [Customer API](/docs/sg/api/customers).
</ResponseField>

<ResponseField name="receivers" type="json object">
  Configuration of desired receivers for the Customer Identifier.
</ResponseField>

<ResponseField name="id" type="string">
  The unique identifier of the virtual bank account. Sample IDs for:

  * Virtual bank account: `ba_Di5gbQsGn0QSz3`
  * Virtual UPI ID: `vpa_CkTmLXqVYPkbxx`
</ResponseField>

<ResponseField name="entity" type="string">
  Name of the entity. Possible values:

  * `bank_account`
  * `vpa`
</ResponseField>

<ResponseField name="ifsc" type="string">
  The IFSC for the virtual bank account created. For example, `RAZR0000001`. This parameter appears in the response only when `bank_account` is passed as the receiver `type`.
</ResponseField>

<ResponseField name="bank_name" type="string">
  The bank associated with the virtual bank account. For example, `RBL Bank`. This parameter appears in the response only when `bank_account` is passed as the receiver `type`.
</ResponseField>

<ResponseField name="account_number" type="string">
  The unique account number provided by the bank. For example, `1112220061746877`. This parameter appears in the response only when `bank_account` is passed as the receiver `type`.
</ResponseField>

<ResponseField name="name" type="string">
  The `merchant billing label` as it appears on the Dashboard. This parameter appears in the response only when `bank_account` is passed as the receiver `type`.
</ResponseField>

<ResponseField name="notes" type="json object">
  Any custom notes you might want to add to the virtual bank account can be entered here. Know more about [notes](/docs/sg/api/understand#notes). This parameter appears in the response only when `bank_account` is passed as the receiver `type`.

  : `json object` Any custom notes you might want to add to the virtual bank account or virtual UPI ID can be entered here. Know more about [notes](/docs/sg/api/understand). This parameter appears in the response only when `bank_account` is passed as the receiver `type`.
</ResponseField>

<ResponseField name="username" type="string">
  The UPI ID consists of the username and the bank handle. The `username` consists of the `namespace` (assigned by the bank to Razorpay), the `merchant prefix` (which can be customised by you) and the `descriptor` (which you provide to identify the customer). The unique identifier which forms the first half of the virtual UPI ID. For example, `rpy.payto00000gaurikumari`. This parameter appears in the response only when `vpa` is passed as the receiver `type`. The descriptor can be 10 characters only.
</ResponseField>

<ResponseField name="handle" type="string">
  The bank name that forms the second half of the virtual UPI ID.  For example, `icici`. This parameter appears in the response only when `vpa` is passed as the receiver `type`.
</ResponseField>

<ResponseField name="address" type="string">
  The UPI ID that combines the `username` and the `handle` with the `@` symbol. For example, `rpy.payto00000gaurikumari@icici`. This parameter appears in the response only when `vpa` is passed as the receiver `type`.
</ResponseField>

<ResponseField name="close_by" type="integer">
  UNIX timestamp at which the Customer Identifier is scheduled to be automatically closed. The time must be at least 15 minutes after current time. The date range can be set till `2147483647` in UNIX timestamp format (equivalent to Tuesday, January 19, 2038 8:44:07 AM GMT+05:30).

  <Warning>
    **Watch Out!**

    * Any request beyond `2147483647` UNIX timestamp will fail.
    * A Customer Identifier API that has not been used for 90 days will be automatically closed even if no `close_by` date has been set.
  </Warning>
</ResponseField>

<ResponseField name="closed_at" type="integer">
  UNIX timestamp at which the Customer Identifier is automatically closed.
</ResponseField>

<ResponseField name="created_at" type="integer">
  UNIX timestamp at which the Customer Identifier was created.
</ResponseField>

## Errors

<AccordionGroup>
  <Accordion
    title="The API `<key/secret>
` provided is invalid."
  >
    **Code:** `4xx`

    Occurs when there is a mismatch between the API credentials passed in the API call and the API credentials generated on the dashboard.

    **Solution:** Make sure that the API keys are active and entered correctly. Also, make sure there are no whitespaces before or after the keys.
  </Accordion>
</AccordionGroup>
